Codeforces Round #398 (Div. 2)

A - Snacktower(water)

题意:一个数字在,所有比他大的数放出来以前,不能被放出来。

思路:瞎搞就好了

 1 #include <bits/stdc++.h>
 2 using namespace std;
 3 const int INF = 0x3f3f3f3f;
 4 const int maxn = 100000 + 5;
 5 typedef long long LL;
 6 typedef pair<int, int>pii;
 7
 8 int main()
 9 {
10     priority_queue<int>que;
11     int n;
12     scanf("%d", &n);
13     int nn = n;
14     for(int i = 0; i < nn; i++)
15     {
16         int x;
17         scanf("%d", &x);
18         que.push(x);
19         if(x == n)
20         {
21             while(que.top() == n)
22             {
23                 printf("%d ", que.top());
24                 que.pop();
25                 n--;
26             }
27         }
28         puts("");
29     }
30
31     return 0;
32 }

B - The Queue

C - Garland(dfs)

题意:给你一棵树,每个结点上都有值,然后问你能不能把,整棵树根据值,断开两条边,平均分成三份。

思路:

  第一次dfs,切掉一段,然后去边,再dfs一次就得到答案了。这题坑点比较多。如果找不到切点或者切点是根,显然是不行的。没考虑到。

  用flag记录cut点而不是直接erase掉的原因是,erase一不小心 就会把迭代器弄乱掉,特别是这种搜索的写法中,要小心。

 1 #include <bits/stdc++.h>
 2 using namespace std;
 3 const int INF = 0x3f3f3f3f;
 4 const int maxn = 1e6 + 5;
 5 typedef long long LL;
 6 typedef pair<int, int>pii;
 7
 8
 9 set<int>G[maxn];
10 int v[maxn];
11 LL cnt[maxn];
12 int flag;
13 LL sum;
14 int cut;
15
16 void dfs(int cur, int pa)
17 {
18     if(cur == flag) return;
19     if(cut != -1)   return ;
20
21     cnt[cur] = v[cur];
22     for(auto o : G[cur])
23     {
24         dfs(o, cur);
25         cnt[cur] += cnt[o];
26     }
27
28     if(cut == -1 && cnt[cur] * 3 == sum)
29     {
30         cut = cur;
31         flag = cur;
32     }
33 }
34 int main()
35 {
36     int n, root;
37     scanf("%d", &n);
38     sum = 0;
39     for(int i = 1; i <= n; i++)
40     {
41         int pa, val;
42         scanf("%d%d", &pa, &val);
43         if(pa == 0) root = i;
44         G[pa].insert(i);
45         v[i] = val;
46         sum += val;
47     }
48
49     flag = -1;
50     cut = -1;
51     dfs(root, -1);
52
53
54     if(cut == -1 || cut == root)
55     {
56         puts("-1");
57     }
58     else
59     {
60         int temp = cut;
61         memset(cnt, 0, sizeof(cnt));
62         cut = -1;
63         dfs(root, -1);
64         if(cut == -1 || cut == root)   puts("-1");
65         else printf("%d %d\n", temp, cut);
66     }
67
68
69     return 0;
70 }

D - Cartons of milk

时间: 2024-12-30 03:25:16

Codeforces Round #398 (Div. 2)的相关文章

【暴力】Codeforces Round #398 (Div. 2) A. Snacktower

题意不复述. 用个bool数组记录一下,如果某一天,当前剩下的最大的出现了的话,就输出一段. #include<cstdio> using namespace std; int n; bool vis[100010]; int main() { // freopen("a.in","r",stdin); scanf("%d",&n); int x; int now=n; for(int i=1;i<=n;++i) { s

Codeforces Round #279 (Div. 2) ABCD

Codeforces Round #279 (Div. 2) 做得我都变绿了! Problems # Name     A Team Olympiad standard input/output 1 s, 256 MB  x2377 B Queue standard input/output 2 s, 256 MB  x1250 C Hacking Cypher standard input/output 1 s, 256 MB  x740 D Chocolate standard input/

Codeforces Round #428 (Div. 2)

Codeforces Round #428 (Div. 2) A    看懂题目意思就知道做了 #include<bits/stdc++.h> using namespace std; #pragma comment(linker, "/STACK:102400000,102400000") #define rep(i,a,b) for (int i=a; i<=b; ++i) #define per(i,b,a) for (int i=b; i>=a; --i

Codeforces Round #424 (Div. 2) D. Office Keys(dp)

题目链接:Codeforces Round #424 (Div. 2) D. Office Keys 题意: 在一条轴上有n个人,和m个钥匙,门在s位置. 现在每个人走单位距离需要单位时间. 每个钥匙只能被一个人拿. 求全部的人拿到钥匙并且走到门的最短时间. 题解: 显然没有交叉的情况,因为如果交叉的话可能不是最优解. 然后考虑dp[i][j]表示第i个人拿了第j把钥匙,然后 dp[i][j]=max(val(i,j),min(dp[i-1][i-1~j]))   val(i,j)表示第i个人拿

Codeforces Round #424 (Div. 2) C. Jury Marks(乱搞)

题目链接:Codeforces Round #424 (Div. 2) C. Jury Marks 题意: 给你一个有n个数序列,现在让你确定一个x,使得x通过挨着加这个序列的每一个数能出现所有给出的k个数. 问合法的x有多少个.题目保证这k个数完全不同. 题解: 显然,要将这n个数求一下前缀和,并且排一下序,这样,能出现的数就可以表示为x+a,x+b,x+c了. 这里 x+a,x+b,x+c是递增的.这里我把这个序列叫做A序列 然后对于给出的k个数,我们也排一下序,这里我把它叫做B序列,如果我

[Codeforces] Round #352 (Div. 2)

人生不止眼前的狗血,还有远方的狗带 A题B题一如既往的丝帛题 A题题意:询问按照12345678910111213...的顺序排列下去第n(n<=10^3)个数是多少 题解:打表,输出 1 #include<bits/stdc++.h> 2 using namespace std; 3 int dig[10],A[1005]; 4 int main(){ 5 int aa=0; 6 for(int i=1;;i++){ 7 int x=i,dd=0; 8 while(x)dig[++dd

Codeforces Round #273 (Div. 2)

Codeforces Round #273 (Div. 2) 题目链接 A:签到,仅仅要推断总和是不是5的倍数就可以,注意推断0的情况 B:最大值的情况是每一个集合先放1个,剩下都丢到一个集合去,最小值是尽量平均去分 C:假如3种球从小到大是a, b, c,那么假设(a + b) 2 <= c这个比較明显答案就是a + b了.由于c肯定要剩余了,假设(a + b)2 > c的话,就肯定能构造出最优的(a + b + c) / 3,由于肯定能够先拿a和b去消除c,而且控制a和b成2倍关系或者消除

Codeforces Round #339 (Div. 2) B. Gena&#39;s Code

B. Gena's Code It's the year 4527 and the tanks game that we all know and love still exists. There also exists Great Gena's code, written in 2016. The problem this code solves is: given the number of tanks that go into the battle from each country, f

Codeforces Round #315 (Div. 1)

A. Primes or Palindromes? time limit per test 3 seconds memory limit per test 256 megabytes input standard input output standard output Rikhail Mubinchik believes that the current definition of prime numbers is obsolete as they are too complex and un